<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center column>


        <v-card width="90%">
            <v-card-title>
                <v-layout row class="fab-container">

                </v-layout>

                <v-layout column>
                    <v-layout wrap>
                        <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                            <v-autocomplete
                                    v-model="filter.owner"
                                    label="صاحب بار"
                                    append-icon="search"
                                    :isLoading="isLoadingOwner"
                                    :search-input.sync="searchOwner"
                                    :items="searchedOwners"
                                    item-text="name"
                                    :filter="customFilter"
                                    return-object
                                    @change="setSelectedOwner"
                            ></v-autocomplete>
                        </v-flex>

                        <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                            <v-autocomplete
                                    v-model="filter.driver"
                                    label="راننده"
                                    append-icon="search"
                                    :isLoading="isLoadingDriver"
                                    :search-input.sync="searchDriver"
                                    :items="searchedDrivers"
                                    item-text="name"
                                    :filter="customFilter"
                                    return-object
                                    @change="setSelectedDriver"
                            ></v-autocomplete>
                        </v-flex>

                        <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                            <v-autocomplete
                                    v-model="filter.carrier"
                                    label="باربری"
                                    append-icon="search"
                                    :isLoading="isLoadingCarrier"
                                    :search-input.sync="searchCarrier"
                                    :items="searchedCarriers"
                                    item-text="name"
                                    :filter="customFilter"
                                    return-object
                                    @change="setSelectedCarrier"
                            ></v-autocomplete>
                        </v-flex>


<!--                        <v-flex xs12 md6 sm6>-->
<!--                            <v-text-field  readonly class="mr-2" v-model="filter.originCity.name"-->
<!--                                           label="شهر مبدا"></v-text-field>-->
<!--                        </v-flex>-->


<!--                        <v-flex xs12 md6 sm6>-->
<!--                            <v-text-field  readonly class="mr-2" v-model="filter.destinationCity.name"-->
<!--                                           label="شهر مقصد"></v-text-field>-->
<!--                        </v-flex>-->

                        <v-flex class="pl-1 p-r1" xs12 sm12 md12>
                            <v-layout wrap>
                                <v-flex xs12 sm12 md4>
                                    <v-layout row>
                                        <h5 class="ma-1 mr-3">
                                            از:
                                        </h5>
                                        <date-picker @input="setStartTime" color="#b71c1c" type="datetime"
                                                     :value="filter.start_time"></date-picker>
                                    </v-layout>
                                </v-flex>
                                <v-flex xs12 sm12 md4>
                                    <v-layout row>
                                        <h5 class="ma-1 mr-3">
                                            تا:
                                        </h5>
                                        <date-picker @input="setEndTime" color="#b71c1c" type="datetime"
                                                     :value="filter.end_time"></date-picker>
                                    </v-layout>
                                </v-flex>
                            </v-layout>
                        </v-flex>
                    </v-layout>
                    <v-layout class="ma-2" row>
                        <v-flex xs12 sm12 md12>
                            <v-btn
                                color="green"
                                dark
                                small
                                top
                                center
                                @click="readData"
                            >
                                اعمال فیلتر ها
                            </v-btn>
                            <v-btn
                                color="error"
                                dark
                                small
                                top
                                center
                                @click="removeFilter"
                            >
                                حذف فیلتر ها
                            </v-btn>
                        </v-flex>

<!--                        <v-btn-->
<!--                            color="error"-->
<!--                            dark-->
<!--                            small-->
<!--                            top-->
<!--                            center-->
<!--                            @click="showOrigin">-->
<!--                            مبدا-->
<!--                        </v-btn>-->

<!--                        <v-btn-->
<!--                            color="error"-->
<!--                            dark-->
<!--                            small-->
<!--                            top-->
<!--                            center-->
<!--                            @click="showDestination">-->
<!--                            مقصد-->
<!--                        </v-btn>-->
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>

        <v-card class="mt-2" width="90%">
            <v-card-title >
                <v-layout column>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false" class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ types[item.type]}}</td>
                            <td>{{ item.amount}}</td>
                            <td>{{ item.discount_percent}}</td>
                            <td>{{ item.summation}}</td>
                            <td>{{ item.value}}</td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="origin" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                    v-model="selectedProvince"
                                    :items="province"
                                    item-text="name"
                                    outlined
                                    label="استان را انتخاب کنید"
                                    single-line
                                    @change="getCity"
                                    return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                    v-show="this.cityPending === false"
                                    v-model="filter.origin"
                                    :items="city"
                                    item-text="name"
                                    outlined
                                    label="شهر را انتخاب کنید"
                                    single-line
                                    @change="setOrigin"
                                    return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideOrigin">بستن</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog v-model="destination" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                    v-model="selectedProvince"
                                    :items="province"
                                    item-text="name"
                                    outlined
                                    label="استان را انتخاب کنید"
                                    single-line
                                    @change="getCity"
                                    return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                    v-show="this.cityPending === false"
                                    v-model="filter.destination"
                                    :items="city"
                                    item-text="name"
                                    outlined
                                    label="شهر را انتخاب کنید"
                                    single-line
                                    @change="setDestination"
                                    return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDestination">بستن</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>


    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "transaction",
        methods: {
            ...mapMutations({
                setStartTime:'transaction/setStartTime',
                setEndTime:'transaction/setEndTime',
                setSelectedOwner:'transaction/setSelectedOwner',
                setSelectedDriver:'transaction/setSelectedDriver',
                setSelectedCarrier:'transaction/setSelectedCarrier',
                setSelectedItem: 'transaction/setSelectedItem',
                showCityPending: 'transaction/showCityPending',
                hideCityPending: 'transaction/hideCityPending',
                showOrigin: 'transaction/showOrigin',
                hideOrigin: 'transaction/hideOrigin',
                showDestination: 'transaction/showDestination',
                hideDestination: 'transaction/hideDestination',
                setSelectedProvince: 'transaction/setSelectedProvince',
            }),
            ...mapActions({
                removeFilter: 'transaction/removeFilter',
                readData: 'transaction/readData',
                setOrigin: 'transaction/setOrigin',
                getCityByProvince: 'transaction/getCityByProvince',
                setDestination: 'transaction/setDestination',
            }),
            add() {
                this.setSelectedItem({
                    id: null,
                    name: null,
                    commission_amount: null,
                });
                this.showAddDialog();
            },
            edit(item){
                this.setSelectedItem(item);
                this.showAddDialog();
            },
            add_Edit(){
                this.addOrEdit();
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
            customFilter(item) {
                return item.first_name + " " + item.last_name;
            },
            getCity(item) {
                console.log('item', item);
                this.setSelectedProvince(item);
                this.getCityByProvince();
            },
        },
        computed: {
            ...mapState({
                allData: state => state.transaction.allData,
                allDataLoading: state => state.transaction.allDataLoading,
                types: state => state.transaction.types,
                searchedOwners: state => state.transaction.searchedOwners,
                isLoadingOwner: state => state.transaction.isLoadingOwner,
                searchedDrivers: state => state.transaction.searchedDrivers,
                isLoadingDriver: state => state.transaction.isLoadingDriver,
                searchedCarriers: state => state.transaction.searchedCarriers,
                isLoadingCarrier: state => state.transaction.isLoadingCarrier,
                filter: state => state.transaction.filter,
                origin: state => state.transaction.origin,
                destination: state => state.transaction.destination,
                cityPending: state => state.transaction.cityPending,
                province: state => state.transaction.province,
                selectedProvince: state => state.transaction.selectedProvince,
                city: state => state.transaction.city,
                city: state => state.transaction.city,

            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                searchOwner:null,
                searchDriver:null,
                searchCarrier:null,
                headers: [
                    {text: 'نوع تراکنش', align: 'right', value: 'type'},
                    {text: 'مقدار', align: 'right', value: 'amount'},
                    {text: 'درصد تخفیف', align: 'right', value: 'discount_percent'},
                    {text: 'حاصل جمع', align: 'right', value: 'summation'},
                    {text: 'مقدار تخفیف', align: 'right', value: 'value'},
                ],
            }
        },
        watch: {
            ...mapActions({
                searchOwner: 'transaction/searchOwner',
                searchDriver : 'transaction/searchDriver',
                searchCarrier : 'transaction/searchCarrier',
            }),
        },

    }
</script>
<style scoped>
</style>
